diff -pruN 4.2.9-5/CHANGELOG 4.3.2-1/CHANGELOG
--- 4.2.9-5/CHANGELOG	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/CHANGELOG	2016-05-24 00:19:14.000000000 +0000
@@ -1,3 +1,22 @@
+== 4.3.1 / May 17th, 2016
+
+* Fix additional case for CVE-2012-6684 [Joshua Siler]
+
+== 4.3.0 / April 29th, 2016
+
+* Remove JRuby and Windows cross compilation and support
+* Add Ruby 2.2.3 testing and support
+
+* include CVE-2012-6684 fix [Tomas Pospisek]
+  * fix by [Antonio Terceiro] 
+    * see http://sources.debian.net/src/ruby-redcloth/4.2.9-4/debian/patches/0001-Filter-out-javascript-links-when-using-filter_html-o.patch/
+  * vulnerability reported by [Kousuke Ebihara] 
+    * see http://co3k.org/blog/redcloth-unfixed-xss-en
+
+== 4.2.9.1 / February 24, 2015
+
+* Lazy-load latex_entities.yml [Charlie Somerville]
+
 == 4.2.9 / November 25, 2011
 
 * Fix RbConfig / Config warning in Ruby 1.9.3. [Steve Purcell, Robert Gleeson, and unclaimedbaggage]
@@ -82,7 +101,7 @@
 * Accept multiline content in table cells. [Jason Garber]
 
 * Change to list attributes so you can give style/class to list items (taken from PyTextile).  Breaks backwards compatibility.
-  
+
   Before, the style applied to the first list item applied to the entire list.  Now, class/id/style placed
   before the list applies to the list element and after the hash or asterisk applies to the list item.  For
   example:
@@ -163,7 +182,7 @@
   To compile the jruby version of the gem: jruby -S rake compile
 
 * Added textilize ERB utility method. [edraut]
-  Use it in an ERB template like this: <%=t my_textile_string %> or 
+  Use it in an ERB template like this: <%=t my_textile_string %> or
   <%=r %{Some *textile* if you please!} %>
 
 * Fix extended blockcode stripping whitespace following blank line. #78
@@ -258,4 +277,4 @@
 
 * Over 500 tests prevent regression
 
-* It's 40 times faster than the previous version.
\ No newline at end of file
+* It's 40 times faster than the previous version.
diff -pruN 4.2.9-5/debian/changelog 4.3.2-1/debian/changelog
--- 4.2.9-5/debian/changelog	2015-07-08 19:34:29.000000000 +0000
+++ 4.3.2-1/debian/changelog	2016-09-13 09:23:00.000000000 +0000
@@ -1,13 +1,17 @@
+ruby-redcloth (4.3.2-1) unstable; urgency=medium
+
+  * Team upload
+  * New upstream release
+  * Remove patches (already applied upstream)
+
+ -- Pirate Praveen <praveen@debian.org>  Tue, 13 Sep 2016 14:52:56 +0530
+
 ruby-redcloth (4.2.9-5) unstable; urgency=medium
 
-  [ Balasankar C ]
   * Team upload.
   * Fix tests to support RSpec 3.x (Closes: #791786)
 
-  [ Christian Hofstaedtler ]
-  * Set Standards-Version to 3.9.6 (no addtl. changes)
-
- -- Christian Hofstaedtler <zeha@debian.org>  Wed, 08 Jul 2015 21:34:27 +0200
+ -- Balasankar C <balasankarc@autistici.org>  Wed, 08 Jul 2015 23:35:08 +0530
 
 ruby-redcloth (4.2.9-4) unstable; urgency=high
 
diff -pruN 4.2.9-5/debian/compat 4.3.2-1/debian/compat
--- 4.2.9-5/debian/compat	2015-07-08 19:31:37.000000000 +0000
+++ 4.3.2-1/debian/compat	2016-09-13 08:19:31.000000000 +0000
@@ -1 +1 @@
-7
+9
diff -pruN 4.2.9-5/debian/control 4.3.2-1/debian/control
--- 4.2.9-5/debian/control	2015-07-08 19:34:04.000000000 +0000
+++ 4.3.2-1/debian/control	2016-09-13 09:53:41.000000000 +0000
@@ -3,17 +3,23 @@ Section: ruby
 Priority: optional
 Maintainer: Debian Ruby Extras Maintainers <pkg-ruby-extras-maintainers@lists.alioth.debian.org>
 Uploaders: Dmitry Borodaenko <angdraug@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), gem2deb (>= 0.6.0~), rake (>= 0.8.7~), ruby-rspec (>= 2.4~), ragel
-Standards-Version: 3.9.6
-Vcs-Git: git://anonscm.debian.org/pkg-ruby-extras/ruby-redcloth.git
-Vcs-Browser: http://anonscm.debian.org/gitweb?p=pkg-ruby-extras/ruby-redcloth.git;a=summary
+Build-Depends: debhelper (>= 9~),
+               gem2deb,
+               ragel,
+               rake (>= 0.8.7~),
+               ruby-rspec (>= 2.4~)
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/pkg-ruby-extras/ruby-redcloth.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ruby-extras/ruby-redcloth.git
 Homepage: https://github.com/jgarber/redcloth
 XS-Ruby-Versions: all
 
 Package: ruby-redcloth
 Architecture: any
 XB-Ruby-Versions: ${ruby:Versions}
-Depends: ${shlibs:Depends}, ${misc:Depends}, ruby | ruby-interpreter
+Depends: ruby | ruby-interpreter,
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: Textile module for Ruby
  Textile is a very simple text format, intended for making readable text
  that can be converted to HTML, and used in docs, blogs, and Wiki pages.
diff -pruN 4.2.9-5/debian/patches/0001-Filter-out-javascript-links-when-using-filter_html-o.patch 4.3.2-1/debian/patches/0001-Filter-out-javascript-links-when-using-filter_html-o.patch
--- 4.2.9-5/debian/patches/0001-Filter-out-javascript-links-when-using-filter_html-o.patch	2015-07-08 19:31:37.000000000 +0000
+++ 4.3.2-1/debian/patches/0001-Filter-out-javascript-links-when-using-filter_html-o.patch	1970-01-01 00:00:00.000000000 +0000
@@ -1,53 +0,0 @@
-From b3d82f0c3a354a2f589e1fd43f5f1d7e427b530e Mon Sep 17 00:00:00 2001
-From: Antonio Terceiro <terceiro@debian.org>
-Date: Sat, 7 Feb 2015 23:27:39 -0200
-Subject: [PATCH] Filter out 'javascript:' links when using filter_html or
- sanitize_html
-
-This is a fix for CVE-2012-6684
----
- lib/redcloth/formatters/html.rb     |  6 +++++-
- spec/security/CVE-2012-6684_spec.rb | 14 ++++++++++++++
- 2 files changed, 19 insertions(+), 1 deletion(-)
- create mode 100644 spec/security/CVE-2012-6684_spec.rb
-
-diff --git a/lib/redcloth/formatters/html.rb b/lib/redcloth/formatters/html.rb
-index bfadfb7..b8793b2 100644
---- a/lib/redcloth/formatters/html.rb
-+++ b/lib/redcloth/formatters/html.rb
-@@ -111,7 +111,11 @@ module RedCloth::Formatters::HTML
-   end
-   
-   def link(opts)
--    "<a href=\"#{escape_attribute opts[:href]}\"#{pba(opts)}>#{opts[:name]}</a>"
-+    if (filter_html || sanitize_html) && opts[:href] =~ /^\s*javascript:/
-+      opts[:name]
-+    else
-+      "<a href=\"#{escape_attribute opts[:href]}\"#{pba(opts)}>#{opts[:name]}</a>"
-+    end
-   end
-   
-   def image(opts)
-diff --git a/spec/security/CVE-2012-6684_spec.rb b/spec/security/CVE-2012-6684_spec.rb
-new file mode 100644
-index 0000000..05219fd
---- /dev/null
-+++ b/spec/security/CVE-2012-6684_spec.rb
-@@ -0,0 +1,14 @@
-+# https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2012-6684
-+
-+require 'redcloth'
-+
-+describe 'CVE-2012-6684' do
-+
-+  it 'should not let javascript links pass through' do
-+    # PoC from http://co3k.org/blog/redcloth-unfixed-xss-en
-+    output = RedCloth.new('["clickme":javascript:alert(%27XSS%27)]', [:filter_html, :filter_styles, :filter_classes, :filter_ids]).to_html
-+    expect(output).to_not match(/href=.javascript:alert/)
-+  end
-+
-+
-+end
--- 
-2.1.4
-
diff -pruN 4.2.9-5/debian/patches/rspec3-test-fix 4.3.2-1/debian/patches/rspec3-test-fix
--- 4.2.9-5/debian/patches/rspec3-test-fix	2015-07-08 19:31:37.000000000 +0000
+++ 4.3.2-1/debian/patches/rspec3-test-fix	1970-01-01 00:00:00.000000000 +0000
@@ -1,29 +0,0 @@
-Description: Fix tests to run with RSpec 3.x
- RSpec 3.x redefined the matchers like be_true and be_false to be_truthy and 
- be_falsey respectively. Fixing the tests to follow those modifications.
-Author: Balasankar C <balasankarc@autistici.org>
-Last-Update: 2015-07-08
----
-This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
---- a/spec/parser_spec.rb
-+++ b/spec/parser_spec.rb
-@@ -11,8 +11,8 @@
-   end
-   
-   it "should have a VERSION" do
--    RedCloth.const_defined?("VERSION").should be_true
--    RedCloth::VERSION.const_defined?("STRING").should be_true
-+    RedCloth.const_defined?("VERSION").should be_truthy
-+    RedCloth::VERSION.const_defined?("STRING").should be_truthy
-   end
-   
-   it "should show the version as a string" do
-@@ -21,7 +21,7 @@
-   end
-   
-   it "should have EXTENSION_LANGUAGE" do
--    RedCloth.const_defined?("EXTENSION_LANGUAGE").should be_true
-+    RedCloth.const_defined?("EXTENSION_LANGUAGE").should be_truthy
-     RedCloth::EXTENSION_LANGUAGE.should_not be_empty
-     RedCloth::DESCRIPTION.should include(RedCloth::EXTENSION_LANGUAGE)
-   end
diff -pruN 4.2.9-5/debian/patches/series 4.3.2-1/debian/patches/series
--- 4.2.9-5/debian/patches/series	2015-07-08 19:31:37.000000000 +0000
+++ 4.3.2-1/debian/patches/series	2016-09-13 09:21:29.000000000 +0000
@@ -1,3 +1 @@
-rspec3-test-fix
 0001-restore-extconf.rb.patch
-0001-Filter-out-javascript-links-when-using-filter_html-o.patch
diff -pruN 4.2.9-5/debian/ruby-tests.rake 4.3.2-1/debian/ruby-tests.rake
--- 4.2.9-5/debian/ruby-tests.rake	2015-07-08 19:31:37.000000000 +0000
+++ 4.3.2-1/debian/ruby-tests.rake	2016-09-13 08:19:31.000000000 +0000
@@ -1,7 +1,5 @@
-require 'rspec/core/rake_task'
+require 'gem2deb/rake/spectask'
 
-RSpec::Core::RakeTask.new(:spec) do |spec|
+Gem2Deb::Rake::RSpecTask.new do |spec|
   spec.pattern = './spec/**/*_spec.rb'
 end
-
-task :default => :spec
diff -pruN 4.2.9-5/Gemfile 4.3.2-1/Gemfile
--- 4.2.9-5/Gemfile	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/Gemfile	2016-05-24 00:19:14.000000000 +0000
@@ -1,7 +1,7 @@
-source :rubygems
+source 'https://rubygems.org'
 gemspec
 
 group :compilation do
-  gem 'rvm', '~> 1.2.6'
+  gem 'rvm', '~> 1.11.3.9'
   gem 'rake-compiler', '~> 0.7.1'
-end
\ No newline at end of file
+end
diff -pruN 4.2.9-5/lib/redcloth/formatters/html.rb 4.3.2-1/lib/redcloth/formatters/html.rb
--- 4.2.9-5/lib/redcloth/formatters/html.rb	2016-09-13 17:38:01.000000000 +0000
+++ 4.3.2-1/lib/redcloth/formatters/html.rb	2016-05-24 00:19:14.000000000 +0000
@@ -111,7 +111,7 @@ module RedCloth::Formatters::HTML
   end
   
   def link(opts)
-    if (filter_html || sanitize_html) && opts[:href] =~ /^\s*javascript:/
+    if (filter_html || sanitize_html) && opts[:href] =~ /^\s*javascript:/i
       opts[:name]
     else
       "<a href=\"#{escape_attribute opts[:href]}\"#{pba(opts)}>#{opts[:name]}</a>"
@@ -119,11 +119,15 @@ module RedCloth::Formatters::HTML
   end
   
   def image(opts)
-    opts.delete(:align)
-    opts[:alt] = opts[:title]
-    img = "<img src=\"#{escape_attribute opts[:src]}\"#{pba(opts)} alt=\"#{escape_attribute opts[:alt].to_s}\" />"  
-    img = "<a href=\"#{escape_attribute opts[:href]}\">#{img}</a>" if opts[:href]
-    img
+    if (filter_html || sanitize_html) && ( opts[:src] =~ /^\s*javascript:/i || opts[:href] =~ /^\s*javascript:/i )
+      opts[:title]
+    else
+      opts.delete(:align)
+      opts[:alt] = opts[:title]
+      img = "<img src=\"#{escape_attribute opts[:src]}\"#{pba(opts)} alt=\"#{escape_attribute opts[:alt].to_s}\" />"  
+      img = "<a href=\"#{escape_attribute opts[:href]}\">#{img}</a>" if opts[:href]
+      img
+    end
   end
   
   def footno(opts)
diff -pruN 4.2.9-5/lib/redcloth/formatters/latex.rb 4.3.2-1/lib/redcloth/formatters/latex.rb
--- 4.2.9-5/lib/redcloth/formatters/latex.rb	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/lib/redcloth/formatters/latex.rb	2016-05-24 00:19:14.000000000 +0000
@@ -3,7 +3,9 @@ require 'yaml'
 module RedCloth::Formatters::LATEX
   include RedCloth::Formatters::Base
 
-  ENTITIES = YAML::load(File.read(File.dirname(__FILE__)+'/latex_entities.yml'))
+  def self.entities
+    @entities ||= YAML.load(File.read(File.dirname(__FILE__)+'/latex_entities.yml'))
+  end
 
   module Settings
     # Maps CSS style names to latex formatting options
@@ -275,8 +277,8 @@ module RedCloth::Formatters::LATEX
   # TODO: what do we do with (unknown) unicode entities ? 
   #
   def entity(opts)
-    text = opts[:text][0..0] == '#' ? opts[:text][1..-1] : opts[:text] 
-    ENTITIES[text]
+    text = opts[:text][0..0] == '#' ? opts[:text][1..-1] : opts[:text]
+    RedCloth::Formatters::LATEX.entities[text]
   end
 
   def dim(opts)
diff -pruN 4.2.9-5/lib/redcloth/version.rb 4.3.2-1/lib/redcloth/version.rb
--- 4.2.9-5/lib/redcloth/version.rb	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/lib/redcloth/version.rb	2016-05-24 00:19:14.000000000 +0000
@@ -1,13 +1,13 @@
 module RedCloth
   module VERSION
     MAJOR = 4
-    MINOR = 2
-    TINY  = 9
-    RELEASE_CANDIDATE = nil
+    MINOR = 3
+    TINY  = 1
+#    RELEASE_CANDIDATE = 0
 
-    STRING = [MAJOR, MINOR, TINY, RELEASE_CANDIDATE].compact.join('.')
-    TAG = "REL_#{[MAJOR, MINOR, TINY, RELEASE_CANDIDATE].compact.join('_')}".upcase.gsub(/\.|-/, '_')
-    FULL_VERSION = "#{[MAJOR, MINOR, TINY, RELEASE_CANDIDATE].compact.join('.')}"
+    STRING = [MAJOR, MINOR, TINY].compact.join('.')
+    TAG = "REL_#{[MAJOR, MINOR, TINY].compact.join('_')}".upcase.gsub(/\.|-/, '_')
+    FULL_VERSION = "#{[MAJOR, MINOR, TINY].compact.join('.')}"
     
     class << self
       def to_s
diff -pruN 4.2.9-5/.pc/0001-Filter-out-javascript-links-when-using-filter_html-o.patch/lib/redcloth/formatters/html.rb 4.3.2-1/.pc/0001-Filter-out-javascript-links-when-using-filter_html-o.patch/lib/redcloth/formatters/html.rb
--- 4.2.9-5/.pc/0001-Filter-out-javascript-links-when-using-filter_html-o.patch/lib/redcloth/formatters/html.rb	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/.pc/0001-Filter-out-javascript-links-when-using-filter_html-o.patch/lib/redcloth/formatters/html.rb	1970-01-01 00:00:00.000000000 +0000
@@ -1,345 +0,0 @@
-module RedCloth::Formatters::HTML
-  include RedCloth::Formatters::Base
-  
-  [:h1, :h2, :h3, :h4, :h5, :h6, :p, :pre, :div].each do |m|
-    define_method(m) do |opts|
-      "<#{m}#{pba(opts)}>#{opts[:text]}</#{m}>\n"
-    end
-  end
-  
-  [:strong, :code, :em, :i, :b, :ins, :sup, :sub, :span, :cite].each do |m|
-    define_method(m) do |opts|
-      opts[:block] = true
-      "<#{m}#{pba(opts)}>#{opts[:text]}</#{m}>"
-    end
-  end
-  
-  def hr(opts)
-    "<hr#{pba(opts)} />\n"
-  end
-  
-  def acronym(opts)
-    opts[:block] = true
-    "<acronym#{pba(opts)}>#{caps(:text => opts[:text])}</acronym>"
-  end
-  
-  def caps(opts)
-    if no_span_caps
-      opts[:text]
-    else
-      opts[:class] = 'caps'
-      span(opts)
-    end
-  end
-  
-  def del(opts)
-    opts[:block] = true
-    "<del#{pba(opts)}>#{opts[:text]}</del>"
-  end
-  
-  [:ol, :ul].each do |m|
-    define_method("#{m}_open") do |opts|
-      opts[:block] = true
-      "#{"\n" if opts[:nest] > 1}#{"\t" * (opts[:nest] - 1)}<#{m}#{pba(opts)}>\n"
-    end
-    define_method("#{m}_close") do |opts|
-      "#{"\t" * (opts[:nest] - 1)}</#{m}>#{"\n" if opts[:nest] <= 1}"
-    end
-  end
-  
-  def li_open(opts)
-    "#{"\t" * opts[:nest]}<li#{pba(opts)}>#{opts[:text]}"
-  end
-  
-  def li_close(opts=nil)
-    "</li>\n"
-  end
-  
-  def dl_open(opts)
-    opts[:block] = true
-    "<dl#{pba(opts)}>\n"
-  end
-  
-  def dl_close(opts=nil)
-    "</dl>\n"
-  end
-  
-  [:dt, :dd].each do |m|
-    define_method(m) do |opts|
-      "\t<#{m}#{pba(opts)}>#{opts[:text]}</#{m}>\n"
-    end
-  end
-  
-  def td(opts)
-    tdtype = opts[:th] ? 'th' : 'td'
-    "\t\t<#{tdtype}#{pba(opts)}>#{opts[:text]}</#{tdtype}>\n"
-  end
-  
-  def tr_open(opts)
-    "\t<tr#{pba(opts)}>\n"
-  end
-  
-  def tr_close(opts)
-    "\t</tr>\n"
-  end
-  
-  def table_open(opts)
-    "<table#{pba(opts)}>\n"
-  end
-  
-  def table_close(opts)
-    "</table>\n"
-  end
-  
-  def bc_open(opts)
-    opts[:block] = true
-    "<pre#{pba(opts)}>"
-  end
-  
-  def bc_close(opts)
-    "</pre>\n"
-  end
-  
-  def bq_open(opts)
-    opts[:block] = true
-    cite = opts[:cite] ? " cite=\"#{ escape_attribute opts[:cite] }\"" : ''
-    "<blockquote#{cite}#{pba(opts)}>\n"
-  end
-  
-  def bq_close(opts)
-    "</blockquote>\n"
-  end
-  
-  def link(opts)
-    "<a href=\"#{escape_attribute opts[:href]}\"#{pba(opts)}>#{opts[:name]}</a>"
-  end
-  
-  def image(opts)
-    opts.delete(:align)
-    opts[:alt] = opts[:title]
-    img = "<img src=\"#{escape_attribute opts[:src]}\"#{pba(opts)} alt=\"#{escape_attribute opts[:alt].to_s}\" />"  
-    img = "<a href=\"#{escape_attribute opts[:href]}\">#{img}</a>" if opts[:href]
-    img
-  end
-  
-  def footno(opts)
-    opts[:id] ||= opts[:text]
-    %Q{<sup class="footnote" id=\"fnr#{opts[:id]}\"><a href=\"#fn#{opts[:id]}\">#{opts[:text]}</a></sup>}
-  end
-  
-  def fn(opts)
-    no = opts[:id]
-    opts[:id] = "fn#{no}"
-    opts[:class] = ["footnote", opts[:class]].compact.join(" ")
-    "<p#{pba(opts)}><a href=\"#fnr#{no}\"><sup>#{no}</sup></a> #{opts[:text]}</p>\n"
-  end
-  
-  def snip(opts)
-    "<pre#{pba(opts)}><code>#{opts[:text]}</code></pre>\n"
-  end
-  
-  def quote1(opts)
-    "&#8216;#{opts[:text]}&#8217;"
-  end
-  
-  def quote2(opts)
-    "&#8220;#{opts[:text]}&#8221;"
-  end
-  
-  def multi_paragraph_quote(opts)
-    "&#8220;#{opts[:text]}"
-  end
-  
-  def ellipsis(opts)
-    "#{opts[:text]}&#8230;"
-  end
-  
-  def emdash(opts)
-    "&#8212;"
-  end
-  
-  def endash(opts)
-    " &#8211; "
-  end
-  
-  def arrow(opts)
-    "&#8594;"
-  end
-  
-  def dim(opts)
-    opts[:text].gsub!('x', '&#215;')
-    opts[:text].gsub!("'", '&#8242;')
-    opts[:text].gsub!('"', '&#8243;')
-    opts[:text]
-  end
-  
-  def trademark(opts)
-    "&#8482;"
-  end
-  
-  def registered(opts)
-    "&#174;"
-  end
-  
-  def copyright(opts)
-    "&#169;"
-  end
-  
-  def entity(opts)
-    "&#{opts[:text]};"
-  end
-  
-  def amp(opts)
-    "&amp;"
-  end
-  
-  def gt(opts)
-    "&gt;"
-  end
-  
-  def lt(opts)
-    "&lt;"
-  end
-  
-  def br(opts)
-    if hard_breaks == false
-      "\n"
-    else
-      "<br#{pba(opts)} />\n"
-    end
-  end
-  
-  def quot(opts)
-    "&quot;"
-  end
-  
-  def squot(opts)
-    "&#8217;"
-  end
-  
-  def apos(opts)
-    "&#39;"
-  end
-  
-  def html(opts)
-    "#{opts[:text]}\n"
-  end
-  
-  def html_block(opts)
-    inline_html(:text => "#{opts[:indent_before_start]}#{opts[:start_tag]}#{opts[:indent_after_start]}") + 
-    "#{opts[:text]}" +
-    inline_html(:text => "#{opts[:indent_before_end]}#{opts[:end_tag]}#{opts[:indent_after_end]}")
-  end
-  
-  def notextile(opts)
-    if filter_html
-      html_esc(opts[:text], :html_escape_preformatted)
-    else
-      opts[:text]
-    end
-  end
-  
-  def inline_html(opts)
-    if filter_html
-      html_esc(opts[:text], :html_escape_preformatted)
-    else
-      "#{opts[:text]}" # nil-safe
-    end
-  end
-  
-  def ignored_line(opts)
-    opts[:text] + "\n"
-  end
-  
-private
-  
-  # escapement for regular HTML (not in PRE tag)
-  def escape(text)
-    html_esc(text)
-  end
-
-  # escapement for HTML in a PRE tag
-  def escape_pre(text)
-    html_esc(text, :html_escape_preformatted)
-  end
-  
-  # escaping for HTML attributes
-  def escape_attribute(text)
-    html_esc(text, :html_escape_attributes)
-  end
-  
-  def after_transform(text)
-    text.chomp!
-  end
-  
-  
-  def before_transform(text)
-    clean_html(text) if sanitize_html
-  end
-  
-  # HTML cleansing stuff
-  BASIC_TAGS = {
-      'a' => ['href', 'title'],
-      'img' => ['src', 'alt', 'title'],
-      'br' => [],
-      'i' => nil,
-      'u' => nil, 
-      'b' => nil,
-      'pre' => nil,
-      'kbd' => nil,
-      'code' => ['lang'],
-      'cite' => nil,
-      'strong' => nil,
-      'em' => nil,
-      'ins' => nil,
-      'sup' => nil,
-      'sub' => nil,
-      'del' => nil,
-      'table' => nil,
-      'tr' => nil,
-      'td' => ['colspan', 'rowspan'],
-      'th' => nil,
-      'ol' => ['start'],
-      'ul' => nil,
-      'li' => nil,
-      'p' => nil,
-      'h1' => nil,
-      'h2' => nil,
-      'h3' => nil,
-      'h4' => nil,
-      'h5' => nil,
-      'h6' => nil, 
-      'blockquote' => ['cite'],
-      'notextile' => nil
-  }
-  
-  # Clean unauthorized tags.
-  def clean_html( text, allowed_tags = BASIC_TAGS )
-    text.gsub!( /<!\[CDATA\[/, '' )
-    text.gsub!( /<(\/*)([A-Za-z]\w*)([^>]*?)(\s?\/?)>/ ) do |m|
-      raw = $~
-      tag = raw[2].downcase
-      if allowed_tags.has_key? tag
-        pcs = [tag]
-        allowed_tags[tag].each do |prop|
-          ['"', "'", ''].each do |q|
-            q2 = ( q != '' ? q : '\s' )
-            if raw[3] =~ /#{prop}\s*=\s*#{q}([^#{q2}]+)#{q}/i
-              attrv = $1
-              next if (prop == 'src' or prop == 'href') and not attrv =~ %r{^(http|https|ftp):}
-              pcs << "#{prop}=\"#{attrv.gsub('"', '\\"')}\""
-              break
-            end
-          end
-        end if allowed_tags[tag]
-        "<#{raw[1]}#{pcs.join " "}#{raw[4]}>"
-      else # Unauthorized tag
-        if block_given?
-          yield m
-        else
-          ''
-        end
-      end
-    end
-  end
-end
diff -pruN 4.2.9-5/.pc/applied-patches 4.3.2-1/.pc/applied-patches
--- 4.2.9-5/.pc/applied-patches	2016-09-13 17:38:01.178628460 +0000
+++ 4.3.2-1/.pc/applied-patches	2016-09-13 17:38:00.718615643 +0000
@@ -1,3 +1 @@
-rspec3-test-fix
 0001-restore-extconf.rb.patch
-0001-Filter-out-javascript-links-when-using-filter_html-o.patch
diff -pruN 4.2.9-5/.pc/rspec3-test-fix/spec/parser_spec.rb 4.3.2-1/.pc/rspec3-test-fix/spec/parser_spec.rb
--- 4.2.9-5/.pc/rspec3-test-fix/spec/parser_spec.rb	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/.pc/rspec3-test-fix/spec/parser_spec.rb	1970-01-01 00:00:00.000000000 +0000
@@ -1,102 +0,0 @@
-require File.dirname(__FILE__) + '/spec_helper'
-
-describe RedCloth do
-  
-  describe "#new" do
-    it "should accept options" do
-      lambda {
-        RedCloth.new("test", [:hard_breaks])
-      }.should_not raise_error(ArgumentError)
-    end
-  end
-  
-  it "should have a VERSION" do
-    RedCloth.const_defined?("VERSION").should be_true
-    RedCloth::VERSION.const_defined?("STRING").should be_true
-  end
-  
-  it "should show the version as a string" do
-    RedCloth::VERSION::STRING.should == RedCloth::VERSION.to_s
-    RedCloth::VERSION.should == RedCloth::VERSION::STRING
-  end
-  
-  it "should have EXTENSION_LANGUAGE" do
-    RedCloth.const_defined?("EXTENSION_LANGUAGE").should be_true
-    RedCloth::EXTENSION_LANGUAGE.should_not be_empty
-    RedCloth::DESCRIPTION.should include(RedCloth::EXTENSION_LANGUAGE)
-  end
-  
-  it "should not segfault on a badly formatted table" do
-    RedCloth.new(%Q{| one | two |\nthree | four |}).to_html.should =~ /td/
-  end
-  
-  it "should not segfault on a table without a block end" do
-    RedCloth.new("| a | b |\n| c | d |\nh3. foo").to_html.should =~ /h3/
-  end
-  
-  it "should not segfault on a table with empty cells" do
-    RedCloth.new(%Q{|one || |\nthree | four |}).to_html.should =~ /td/
-  end
-  
-  it "should not segfault on an unfinished html block with filter_html" do
-    lambda { RedCloth.new(%Q{<hr> Some text}, [:filter_html]).to_html }.should_not raise_error
-  end
-  
-  it "should parse RedCloth::VERSION in input" do
-    RedCloth.new("RedCloth::VERSION").to_html.should == "<p>#{RedCloth::VERSION::STRING}</p>"
-  end
-  
-  it "should not parse RedCloth::VERSION if it's not on a line by itself" do
-    input = "RedCloth::VERSION won't output the RedCloth::VERSION unless it's on a line all by itself.\n\nRedCloth::VERSION"
-    html = "<p>RedCloth::<span class=\"caps\">VERSION</span> won&#8217;t output the RedCloth::<span class=\"caps\">VERSION</span> unless it&#8217;s on a line all by itself.</p>\n<p>#{RedCloth::VERSION::STRING}</p>"
-    RedCloth.new(input).to_html.should == html
-  end
-  
-  it "should output the RedCloth::VERSION if it's labeled on a line by itself" do
-    input = "RedCloth::VERSION: RedCloth::VERSION"
-    html = "<p>RedCloth::VERSION: #{RedCloth::VERSION::STRING}</p>"
-    RedCloth.new(input).to_html.should == html
-  end
-  
-  it "should output the RedCloth::VERSION if it's labeled in a sentence on a line by itself" do
-    input = "RedCloth version RedCloth::VERSION"
-    html = "<p>RedCloth version #{RedCloth::VERSION::STRING}</p>"
-    RedCloth.new(input).to_html.should == html
-  end
-  
-  it "should output the RedCloth::VERSION in brackets" do
-    input = "The current RedCloth version is [RedCloth::VERSION]"
-    html = "<p>The current RedCloth version is #{RedCloth::VERSION::STRING}</p>"
-    RedCloth.new(input).to_html.should == html
-  end
-  
-  it "should strip carriage returns" do
-    input = "This is a paragraph\r\n\r\nThis is a\r\nline break.\r\n\r\n<div>\r\ntest\r\n\r\n</div>"
-    html = "<p>This is a paragraph</p>\n<p>This is a<br />\nline break.</p>\n<div>\n<p>test</p>\n</div>"
-    RedCloth.new(input).to_html.should == html
-  end
-
-  it "should not add spurious li tags to the end of markup" do
-    input         = "* one\n* two\n* three \n\n"
-    failing_input = "* one\n* two\n* three \n\n\n"
-    RedCloth.new(input).to_html.should_not match(/<li>$/)
-    RedCloth.new(failing_input).to_html.should_not match(/<li>$/)
-  end
-  
-  if RUBY_VERSION > "1.9.0"
-    it "should preserve character encoding" do
-      input = "This is an ISO-8859-1 string"
-      input.force_encoding 'iso-8859-1'
-      output = RedCloth.new(input).to_html
-      
-      output.should == "<p>This is an <span class=\"caps\">ISO</span>-8859-1 string</p>"
-      output.encoding.to_s.should == "ISO-8859-1"
-    end
-    
-    it "should not raise ArgumentError: invalid byte sequence" do
-      s = "\xa3"
-      s.force_encoding 'iso-8859-1'
-      lambda { RedCloth.new(s).to_html }.should_not raise_error
-    end
-  end
-end
diff -pruN 4.2.9-5/ragel/redcloth_attributes.java.rl 4.3.2-1/ragel/redcloth_attributes.java.rl
--- 4.2.9-5/ragel/redcloth_attributes.java.rl	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/ragel/redcloth_attributes.java.rl	1970-01-01 00:00:00.000000000 +0000
@@ -1,83 +0,0 @@
-/*
- * redcloth_attributes.rl
- *
- * Copyright (C) 2009 Jason Garber
- */
-import java.io.IOException;
-
-import org.jruby.Ruby;
-import org.jruby.RubyArray;
-import org.jruby.RubyClass;
-import org.jruby.RubyHash;
-import org.jruby.RubyModule;
-import org.jruby.RubyNumeric;
-import org.jruby.RubyObject;
-import org.jruby.RubyString;
-import org.jruby.RubySymbol;
-import org.jruby.anno.JRubyMethod;
-import org.jruby.runtime.Block;
-import org.jruby.runtime.CallbackFactory;
-import org.jruby.runtime.builtin.IRubyObject;
-import org.jruby.exceptions.RaiseException;
-import org.jruby.runtime.load.BasicLibraryService;
-
-import org.jruby.util.ByteList;
-
-public class RedclothAttributes extends RedclothScanService.Base {
-
-%%{
-
-  machine redcloth_attributes;
-  include redcloth_common "redcloth_common.java.rl";
-  include redcloth_attributes "redcloth_attributes.rl";
-
-}%%
-
-%% write data nofinal;
-
-  private int machine;
-   
-  public RedclothAttributes(int machine, IRubyObject self, byte[] data, int p, int pe) {
-    this.runtime = self.getRuntime();
-    this.self = self;
-
-    // This is GROSS but necessary for EOF matching
-    this.data = new byte[pe+1];
-    System.arraycopy(data, p, this.data, 0, pe);
-    this.data[pe] = 0;
-
-    this.p = 0;
-    this.pe = pe+1;
-    this.eof = this.pe;
-    this.orig_p = 0;
-    this.orig_pe = this.pe;
-
-    this.regs = RubyHash.newHash(runtime);
-    this.attr_regs = RubyHash.newHash(runtime);
-    this.machine = machine;
-  }
-
-  public IRubyObject parse() {
-    %% write init;
-  
-    cs = machine;
-
-    %% write exec;
-
-    return regs;
-  }
-
-  public static IRubyObject attributes(IRubyObject self, IRubyObject str) {
-    ByteList bl = str.convertToString().getByteList();
-    int cs = redcloth_attributes_en_inline;
-    return new RedclothAttributes(cs, self, bl.bytes, bl.begin, bl.realSize).parse();
-  }
-
-  public static IRubyObject link_attributes(IRubyObject self, IRubyObject str) {
-    Ruby runtime = self.getRuntime();
-
-    ByteList bl = str.convertToString().getByteList();
-    int cs = redcloth_attributes_en_link_says;
-    return new RedclothAttributes(cs, self, bl.bytes, bl.begin, bl.realSize).parse();
-  }
-}
diff -pruN 4.2.9-5/ragel/redcloth_common.java.rl 4.3.2-1/ragel/redcloth_common.java.rl
--- 4.2.9-5/ragel/redcloth_common.java.rl	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/ragel/redcloth_common.java.rl	1970-01-01 00:00:00.000000000 +0000
@@ -1,25 +0,0 @@
-%%{
-
-  machine redcloth_common;
-
-  action esc { strCatEscaped(self, block, data, ts, te); }
-  action esc_pre { strCatEscapedForPreformatted(self, block, data, ts, te); }
-  action ignore { ((RubyString)block).append(self.callMethod(runtime.getCurrentContext(), "ignore", regs)); }
-  
-  # conditionals
-  action starts_line {
-    p == orig_p || data[(p-1)] == '\r' || data[(p-1)] == '\n' || data[(p-1)] == '\f'
-  }
-  action starts_phrase {
-    p == orig_p || data[(p-1)] == '\r' || data[(p-1)] == '\n' || data[(p-1)] == '\f' || data[(p-1)] == ' '
-  }
-  action extended { !extend.isNil() }
-  action not_extended { extend.isNil() }
-  action following_hash_is_ol_not_id { 
-    (data[(p+1)] == '#') ? (data[(p+2)] == '#' || data[(p+2)] == '*' || data[(p+2)] == ' ') : true
-  }
-  
-  
-  include redcloth_common "redcloth_common.rl";
-
-}%%;
diff -pruN 4.2.9-5/ragel/redcloth_inline.java.rl 4.3.2-1/ragel/redcloth_inline.java.rl
--- 4.2.9-5/ragel/redcloth_inline.java.rl	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/ragel/redcloth_inline.java.rl	1970-01-01 00:00:00.000000000 +0000
@@ -1,141 +0,0 @@
-/*
- * redcloth_inline.rl
- *
- * Copyright (C) 2009 Jason Garber
- */
-import java.io.IOException;
-
-import org.jruby.Ruby;
-import org.jruby.RubyArray;
-import org.jruby.RubyClass;
-import org.jruby.RubyHash;
-import org.jruby.RubyModule;
-import org.jruby.RubyNumeric;
-import org.jruby.RubyObject;
-import org.jruby.RubyString;
-import org.jruby.RubySymbol;
-import org.jruby.anno.JRubyMethod;
-import org.jruby.runtime.Block;
-import org.jruby.runtime.CallbackFactory;
-import org.jruby.runtime.builtin.IRubyObject;
-import org.jruby.exceptions.RaiseException;
-import org.jruby.runtime.load.BasicLibraryService;
-
-import org.jruby.util.ByteList;
-
-public class RedclothInline extends RedclothScanService.Base {
-
-%%{
-
-  machine redcloth_inline;
-  include redcloth_common "redcloth_common.java.rl";
-  include redcloth_inline "redcloth_inline.rl";
-
-}%%
-
-%% write data nofinal;
-
-  public IRubyObject red_pass_code(IRubyObject self, IRubyObject regs, IRubyObject ref, String meth) {
-    IRubyObject txt = ((RubyHash)regs).aref(ref);
-    if(!txt.isNil()) {
-      IRubyObject txt2 = RubyString.newEmptyString(runtime);
-      strCatEscapedForPreformatted(self, txt2, ((RubyString)txt).getByteList().bytes, ((RubyString)txt).getByteList().begin, ((RubyString)txt).getByteList().begin + ((RubyString)txt).getByteList().realSize);
-      ((RubyHash)regs).aset(ref, txt2);
-    }
-    return self.callMethod(runtime.getCurrentContext(), meth, regs);
-  }
-
-  public IRubyObject red_parse_attr(IRubyObject self, IRubyObject regs, IRubyObject ref) {
-    IRubyObject txt = ((RubyHash)regs).aref(ref);
-    IRubyObject new_regs = RedclothAttributes.attributes(self, txt);
-    return regs.callMethod(runtime.getCurrentContext(), "merge!", new_regs);
-  }
-
-  public IRubyObject red_parse_link_attr(IRubyObject self, IRubyObject regs, IRubyObject ref) {
-    IRubyObject txt = ((RubyHash)regs).aref(ref);
-    IRubyObject new_regs = red_parse_title(RedclothAttributes.link_attributes(self, txt), ref);
-    return regs.callMethod(runtime.getCurrentContext(), "merge!", new_regs);
-  }
-
-  public IRubyObject red_parse_image_attr(IRubyObject self, IRubyObject regs, IRubyObject ref) {
-    return red_parse_title(regs, ref);
-  }
-
-  public IRubyObject red_parse_title(IRubyObject regs, IRubyObject ref) {
-    IRubyObject name = ((RubyHash)regs).aref(ref);
-    if ( !name.isNil() ) {
-      String s = name.convertToString().toString();
-      int p = s.length();
-      if (s.charAt(p - 1) == ')') {
-        int level = -1;
-        p--;
-        while (p > 0 && level < 0) {
-          switch(s.charAt(p - 1)) {
-            case '(': ++level; break;
-            case ')': --level; break;
-          }
-          --p;
-        }
-        IRubyObject title = runtime.newString(s.substring(p + 1, s.length() - 1));
-        if(p > 0 && s.charAt(p - 1) == ' ') --p;
-        if(p != 0) {
-          ((RubyHash)regs).aset(ref, runtime.newString(s.substring(0, p)));
-          ((RubyHash)regs).aset(runtime.newSymbol("title"), title);
-        }
-      }
-    }
-    return regs;
-  }
-
-  public void PASS_CODE(IRubyObject H, String A, String T) {
-    ((RubyString)H).append(red_pass_code(self, regs, runtime.newSymbol(A), T));
-  }
-
-  public void PARSE_ATTR(String A) {
-    red_parse_attr(self, regs, runtime.newSymbol(A));
-  }
-
-  public void PARSE_LINK_ATTR(String A) {
-    red_parse_link_attr(self, regs, runtime.newSymbol(A));
-  }
-
-  public void PARSE_IMAGE_ATTR(String A) {
-    red_parse_image_attr(self, regs, runtime.newSymbol(A));
-  }
-
-  private int opts;
-
-  public RedclothInline(IRubyObject self, byte[] data, int p, int pe, IRubyObject refs) {
-    this.runtime = self.getRuntime();
-    this.self = self;
-    
-    // This is GROSS but necessary for EOF matching
-    this.data = new byte[pe+1];
-    System.arraycopy(data, p, this.data, 0, pe);
-    this.data[pe] = 0;
-
-    this.p = 0;
-    this.pe = pe+1;
-    this.eof = this.pe;
-    this.orig_p = 0;
-    this.orig_pe = this.pe;
-    this.refs = refs;
-    this.block = RubyString.newEmptyString(runtime);
-    this.regs = runtime.getNil();
-    this.attr_regs = runtime.getNil();
-    this.opts = 0;
-  }
-
-
-  public IRubyObject inline() {
-    %% write init;
-    %% write exec;
-
-    return block;
-  }
-
-  public static IRubyObject inline2(IRubyObject self, IRubyObject str, IRubyObject refs) {
-    ByteList bl = str.convertToString().getByteList();
-    return new RedclothInline(self, bl.bytes, bl.begin, bl.realSize, refs).inline();
-  }
-}
diff -pruN 4.2.9-5/ragel/redcloth_scan.java.rl 4.3.2-1/ragel/redcloth_scan.java.rl
--- 4.2.9-5/ragel/redcloth_scan.java.rl	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/ragel/redcloth_scan.java.rl	1970-01-01 00:00:00.000000000 +0000
@@ -1,642 +0,0 @@
-/*
- * redcloth_scan.java.rl
- *
- * Copyright (C) 2009 Jason Garber
- */
-import java.io.IOException;
-
-import org.jruby.Ruby;
-import org.jruby.RubyArray;
-import org.jruby.RubyClass;
-import org.jruby.RubyHash;
-import org.jruby.RubyModule;
-import org.jruby.RubyNumeric;
-import org.jruby.RubyObject;
-import org.jruby.RubyString;
-import org.jruby.RubySymbol;
-import org.jruby.anno.JRubyMethod;
-import org.jruby.runtime.Arity;
-import org.jruby.runtime.Block;
-import org.jruby.runtime.CallbackFactory;
-import org.jruby.runtime.builtin.IRubyObject;
-import org.jruby.exceptions.RaiseException;
-import org.jruby.runtime.load.BasicLibraryService;
-import org.jruby.util.ByteList;
-
-public class RedclothScanService implements BasicLibraryService {
-
-  public static class Base {
-    
-    public void SET_ATTRIBUTES() {
-      SET_ATTRIBUTE("class_buf", "class");
-      SET_ATTRIBUTE("id_buf", "id");
-      SET_ATTRIBUTE("lang_buf", "lang");
-      SET_ATTRIBUTE("style_buf", "style");
-      regs.callMethod(runtime.getCurrentContext(), "merge!", attr_regs);
-      attr_regs = RubyHash.newHash(runtime);
-    }
-
-    public void SET_ATTRIBUTE(String B, String A) {
-      if(!((RubyHash)regs).aref(runtime.newSymbol(B)).isNil()) {
-        ((RubyHash)regs).aset(runtime.newSymbol(A), ((RubyHash)regs).aref(runtime.newSymbol(B)));
-      }
-    }
-    
-    public void CLEAR_LIST() {
-      list_layout = runtime.newArray();
-    }
-    
-    public void SET_LIST_TYPE(String T) {
-      list_type = T;
-    }
-    
-    public void NEST() {
-      nest ++;
-    }
-    
-    public void RESET_NEST() {
-      nest = 0;
-    }
-    
-   public void LIST_LAYOUT() {
-     int aint = 0;
-     IRubyObject aval = ((RubyArray)list_index).entry(nest-1);
-     if(!aval.isNil()) { aint = RubyNumeric.fix2int(aval); }
-     if(list_type.equals("ol") && nest > 0) { 
-       ((RubyArray)list_index).store(nest-1, runtime.newFixnum(aint + 1));
-     }
-
-     if(nest > ((RubyArray)list_layout).getLength()) {
-       SET_ATTRIBUTES();
-       listm = list_type + "_open";       
-       if( !((RubyHash)regs).aref(runtime.newSymbol("list_continue")).isNil() ) {
-         ((RubyHash)regs).aset(runtime.newSymbol("list_continue"), runtime.getNil());
-         ((RubyHash)regs).aset(runtime.newSymbol("start"), ((RubyArray)list_index).entry(nest-1));
-       } else {
-         IRubyObject start = ((RubyHash)regs).aref(runtime.newSymbol("start"));
-         if(start.isNil()) {
-           ((RubyArray)list_index).store(nest-1, runtime.newFixnum(1));
-         } else {
-           IRubyObject start_num = start.callMethod(runtime.getCurrentContext(), "to_i");
-           ((RubyArray)list_index).store(nest-1, start_num);
-         }          
-       }
-       ((RubyHash)regs).aset(runtime.newSymbol("nest"), runtime.newFixnum(nest));
-       ((RubyString)html).append(self.callMethod(runtime.getCurrentContext(), listm, regs));
-       ((RubyArray)list_layout).store(nest-1, runtime.newString(list_type));
-       regs = RubyHash.newHash(runtime);
-       ASET("first", "true");
-     }
-     LIST_CLOSE();
-     if (nest != 0) LIST_ITEM_CLOSE();
-     CLEAR_REGS();
-     ((RubyHash)regs).aset(runtime.newSymbol("nest"), ((RubyArray)list_layout).length());
-     ASET("type", "li_open");
-   }
-
-   public void LIST_ITEM_CLOSE() {
-     if ( ((RubyHash)regs).aref(runtime.newSymbol("first")).isNil() )
-          ((RubyString)html).append(self.callMethod(runtime.getCurrentContext(), "li_close", regs));
-   }
-
-   public void LIST_CLOSE() {
-     while(nest < ((RubyArray)list_layout).getLength()) {
-       ((RubyHash)regs).aset(runtime.newSymbol("nest"), ((RubyArray)list_layout).length());
-       IRubyObject end_list = ((RubyArray)list_layout).pop(runtime.getCurrentContext());
-       if(!end_list.isNil()) {
-         String s = end_list.convertToString().toString();
-         listm = s + "_close";
-         LIST_ITEM_CLOSE();
-         ((RubyString)html).append(self.callMethod(runtime.getCurrentContext(), listm, regs));
-       }
-     }
-   }
-
-   public void TRANSFORM(String T) {
-     if(p > reg && reg >= ts) {
-       IRubyObject str = RedclothScanService.transform(self, data, reg, p-reg, refs);
-       ((RubyHash)regs).aset(runtime.newSymbol(T), str);
-     } else {
-       ((RubyHash)regs).aset(runtime.newSymbol(T), runtime.getNil());
-     } 
-   }
-
-    public IRubyObject red_pass(IRubyObject self, IRubyObject regs, IRubyObject ref, String meth, IRubyObject refs) {
-      IRubyObject txt = ((RubyHash)regs).aref(ref);
-      if(!txt.isNil()) {
-        ((RubyHash)regs).aset(ref, inline2(self, txt, refs));
-      }
-      return self.callMethod(self.getRuntime().getCurrentContext(), meth, regs);
-    }
-
-   
-    public void PASS(IRubyObject H, String A, String T) {
-      ((RubyString)H).append(red_pass(self, regs, runtime.newSymbol(A), T, refs));
-    }   
-
-    
-    public void STORE_LINK_ALIAS() {
-      ((RubyHash)refs_found).aset(((RubyHash)regs).aref(runtime.newSymbol("text")), ((RubyHash)regs).aref(runtime.newSymbol("href")));
-    }
-
-    public void STORE_URL(String T) {
-      if(p > reg && reg >= ts) {
-        boolean punct = true;
-        while(p > reg && punct) {
-          switch(data[p - 1]) {
-            case ')':
-              int tempP = p - 1;
-              int level = -1;
-              while(tempP > reg) {
-                switch(data[tempP - 1]) {
-                  case '(': ++level; break;
-                  case ')': --level; break;
-                }
-                --tempP;
-              }
-              if (level == 0) { punct = false; } else { --p; }
-              break;
-            case '!': case '"': case '#': case '$': case '%': case ']': case '[': case '&': case '\'':
-            case '*': case '+': case ',': case '-': case '.': case '(': case ':':
-            case ';': case '=': case '?': case '@': case '\\': case '^': case '_':
-            case '`': case '|': case '~': p--; break;
-            default: punct = false;
-          }
-        }
-        te = p;
-      }
-
-      STORE(T);
-
-      if(!refs.isNil() && refs.callMethod(runtime.getCurrentContext(), "has_key?", ((RubyHash)regs).aref(runtime.newSymbol(T))).isTrue()) {
-        ((RubyHash)regs).aset(runtime.newSymbol(T), ((RubyHash)refs).aref(((RubyHash)regs).aref(runtime.newSymbol(T))));
-      }
-    }
-
-    public void red_inc(IRubyObject regs, IRubyObject ref) {
-      int aint = 0;
-      IRubyObject aval = ((RubyHash)regs).aref(ref);
-      if(!aval.isNil()) {
-        aint = RubyNumeric.fix2int(aval);
-      }
-      ((RubyHash)regs).aset(ref, regs.getRuntime().newFixnum(aint+1));
-    }
-
-    public IRubyObject red_blockcode(IRubyObject self, IRubyObject regs, IRubyObject block) {
-      Ruby runtime = self.getRuntime();
-      IRubyObject btype = ((RubyHash)regs).aref(runtime.newSymbol("type"));
-      if(((RubyString)block).getByteList().realSize > 0) {
-        ((RubyHash)regs).aset(runtime.newSymbol("text"), block);
-        block = self.callMethod(runtime.getCurrentContext(), btype.asJavaString(), regs);
-      }
-      return block;
-    }
-
-    public IRubyObject red_block(IRubyObject self, IRubyObject regs, IRubyObject block, IRubyObject refs) {
-      Ruby runtime = self.getRuntime();
-      RubySymbol method;
-      IRubyObject sym_text = runtime.newSymbol("text");
-      IRubyObject btype = ((RubyHash)regs).aref(runtime.newSymbol("type"));
-      block = block.callMethod(runtime.getCurrentContext(), "strip");
-
-      if(!block.isNil() && !btype.isNil()) {
-        method = btype.convertToString().intern();
-
-        if(method == runtime.newSymbol("notextile")) {
-          ((RubyHash)regs).aset(sym_text, block);
-        } else {
-          ((RubyHash)regs).aset(sym_text, inline2(self, block, refs));
-        }
-
-        IRubyObject formatterMethods = ((RubyObject)self).callMethod(runtime.getCurrentContext(), "formatter_methods");
-        if( ((RubyArray)formatterMethods).includes(runtime.getCurrentContext(), method) ) {
-          block = self.callMethod(runtime.getCurrentContext(), method.asJavaString(), regs);
-        } else {
-          IRubyObject fallback = ((RubyHash)regs).aref(runtime.newSymbol("fallback"));
-          if(!fallback.isNil()) {
-            ((RubyString)fallback).append(((RubyHash)regs).aref(sym_text));
-            regs = RubyHash.newHash(runtime);
-            ((RubyHash)regs).aset(sym_text, fallback);
-          }
-          block = self.callMethod(runtime.getCurrentContext(), "p", regs);
-        }
-      }
-
-      return block;
-    }
-
-    public void strCatEscaped(IRubyObject self, IRubyObject str, byte[] data, int ts, int te) {
-      IRubyObject sourceStr = RubyString.newString(self.getRuntime(), data, ts, te-ts);
-      IRubyObject escapedStr = self.callMethod(self.getRuntime().getCurrentContext(), "escape", sourceStr);
-      ((RubyString)str).concat(escapedStr);
-    }
-
-    public void strCatEscapedForPreformatted(IRubyObject self, IRubyObject str, byte[] data, int ts, int te) { 
-      IRubyObject sourceStr = RubyString.newString(self.getRuntime(), data, ts, te-ts);
-      IRubyObject escapedStr = self.callMethod(self.getRuntime().getCurrentContext(), "escape_pre", sourceStr);
-      ((RubyString)str).concat(escapedStr);
-    }
-
-    public void CLEAR(IRubyObject obj) {
-      if(block == obj) {
-        block = RubyString.newEmptyString(runtime);
-      } else if(html == obj) { 
-        html = RubyString.newEmptyString(runtime);
-      } else if(table == obj) {
-        table = RubyString.newEmptyString(runtime);
-      }
-    }
-
-    public void ADD_BLOCK() {
-      ((RubyString)html).append(red_block(self, regs, block, refs));
-      extend = runtime.getNil();
-      CLEAR(block);
-      CLEAR_REGS();      
-    }
-
-    public void CLEAR_REGS() {
-      regs = RubyHash.newHash(runtime);
-      attr_regs = RubyHash.newHash(runtime);
-    }
-
-    public void RESET_REG() {
-      reg = -1;
-    }
-
-    public void MARK() {
-      reg = p;
-    }
-
-    public void MARK_B() {
-      bck = p;
-    }
-
-    public void MARK_ATTR() {
-      attr_reg = p;
-    }
-
-    public void CAT(IRubyObject H) {
-      ((RubyString)H).cat(data, ts, te-ts);
-    }
-
-    public void SET_PLAIN_BLOCK(String T) {
-      plain_block = runtime.newString(T);
-    }
-
-    public void RESET_TYPE() {
-      ((RubyHash)regs).aset(runtime.newSymbol("type"), plain_block);
-    }
-
-    public void INLINE(IRubyObject H, String T) {
-      ((RubyString)H).append(self.callMethod(runtime.getCurrentContext(), T, regs));
-    }
-
-    public void RSTRIP_BANG(IRubyObject H) {
-      ((RubyString)H).callMethod(runtime.getCurrentContext(), "rstrip!");
-    }
-
-    public void DONE(IRubyObject H) {
-      ((RubyString)html).append(H);
-      CLEAR(H);
-      CLEAR_REGS();
-    }
-
-    public void ADD_EXTENDED_BLOCK() {
-      ((RubyString)html).append(red_block(self, regs, block, refs));
-      CLEAR(block);
-    }
-
-    public void ADD_BLOCKCODE() {
-      ((RubyString)html).append(red_blockcode(self, regs, block));
-      CLEAR(block);
-      CLEAR_REGS();
-    }
-
-    public void ADD_EXTENDED_BLOCKCODE() {
-      ((RubyString)html).append(red_blockcode(self, regs, block));
-      CLEAR(block);
-    }
-
-
-    public void ATTR_INC(String T) {
-      red_inc(attr_regs, runtime.newSymbol(T));
-    }
-
-    public void INC(int N) {
-      N++;
-    }
-
-    public void END_EXTENDED() {
-      extend = runtime.getNil();
-      CLEAR_REGS();
-    }
-
-    public void ASET(String T, String V) {
-      ((RubyHash)regs).aset(runtime.newSymbol(T), runtime.newString(V));
-    }
-
-    public void ATTR_SET(String T, String V) {
-      ((RubyHash)attr_regs).aset(runtime.newSymbol(T), runtime.newString(V));
-    }
-
-    public void STORE(String T) {
-      if(p > reg && reg >= ts) {
-      
-        IRubyObject str = RubyString.newString(runtime, data, reg, p-reg);
-        ((RubyHash)regs).aset(runtime.newSymbol(T), str);
-      } else {
-        ((RubyHash)regs).aset(runtime.newSymbol(T), runtime.getNil());
-      }
-    }
-
-    public void STORE_B(String T) {
-      if(p > bck && bck >= ts) {
-        IRubyObject str = RubyString.newString(runtime, data, bck, p-bck);
-        ((RubyHash)regs).aset(runtime.newSymbol(T), str);
-      } else {
-        ((RubyHash)regs).aset(runtime.newSymbol(T), runtime.getNil());
-      }
-    }
-
-    public void STORE_ATTR(String T) {
-      if(p > attr_reg && attr_reg >= ts) {
-        IRubyObject str = RubyString.newString(runtime, data, attr_reg, p-attr_reg);
-        ((RubyHash)attr_regs).aset(runtime.newSymbol(T), str);
-      } else {
-        ((RubyHash)attr_regs).aset(runtime.newSymbol(T), runtime.getNil());
-      }
-    }
-
-    public IRubyObject self;
-    public byte[] data;
-    public int p, pe;
-    public IRubyObject refs;
-
-    public Ruby runtime;
-    public int orig_p, orig_pe;
-    public int cs, act, nest;
-    public int ts = -1;
-    public int te = -1;
-    public int reg = -1;
-    public int bck = -1;
-    public int attr_reg = -1;
-    public int eof = -1;
-
-    public IRubyObject html;
-    public IRubyObject table;
-    public IRubyObject block;
-    public IRubyObject regs;
-    public IRubyObject attr_regs;
-
-    public IRubyObject list_layout;
-    public String list_type = null;
-    public IRubyObject list_index;
-    public IRubyObject plain_block;
-    public IRubyObject extend;
-    public String listm = "";
-    public IRubyObject refs_found;
-  }
-
-  private static class Transformer extends Base {
-%%{
-
-  machine redcloth_scan;
-  include redcloth_common "redcloth_common.java.rl";
-
-  action extend { extend = ((RubyHash)regs).aref(runtime.newSymbol("type")); }
-
-  include redcloth_scan "redcloth_scan.rl";
-
-}%%
-
-%% write data nofinal;
-
-    public Transformer(IRubyObject self, byte[] data, int p, int pe, IRubyObject refs) {
-      if(p+pe > data.length) {
-        throw new RuntimeException("BLAHAHA");
-      }
-      this.self = self;
-
-    // This is GROSS but necessary for EOF matching
-    this.data = new byte[pe+1];
-    System.arraycopy(data, p, this.data, 0, pe);
-    this.data[pe] = 0;
-
-    this.p = 0;
-    this.pe = pe+1;
-    this.eof = this.pe;
-    this.orig_p = 0;
-    this.orig_pe = this.pe;
-
-      this.refs = refs;
-      
-      runtime = self.getRuntime();
-
-      html = RubyString.newEmptyString(runtime);
-      table = RubyString.newEmptyString(runtime);
-      block = RubyString.newEmptyString(runtime);
-      CLEAR_REGS();
-
-      list_layout = runtime.getNil();
-      list_index = runtime.newArray();
-      SET_PLAIN_BLOCK("p");
-      extend = runtime.getNil();
-      refs_found = RubyHash.newHash(runtime);
-    }
-
-    public IRubyObject transform() {
-      %% write init;
-
-      %% write exec;
-
-      if(((RubyString)block).getByteList().realSize > 0) {
-        ADD_BLOCK();
-      }
-
-      if(refs.isNil() && !refs_found.callMethod(runtime.getCurrentContext(), "empty?").isTrue()) {
-        return RedclothScanService.transform(self, data, orig_p, orig_pe, refs_found);
-      } else {
-        self.callMethod(self.getRuntime().getCurrentContext(), "after_transform", html);
-        return html;
-      }
-    }
-  }
-
-  public static IRubyObject transform(IRubyObject self, byte[] data, int p, int pe, IRubyObject refs) {
-    return new Transformer(self, data, p, pe, refs).transform();
-  }
-  
-  public static IRubyObject inline2(IRubyObject workingCopy, IRubyObject self, IRubyObject refs) {
-    return RedclothInline.inline2(workingCopy, self, refs);
-  }
-
-  public static IRubyObject transform2(IRubyObject self, IRubyObject str) {
-    RubyString ss = str.convertToString();
-    self.callMethod(self.getRuntime().getCurrentContext(), "before_transform", ss);
-    return transform(self, ss.getByteList().bytes(), ss.getByteList().begin, ss.getByteList().realSize, self.getRuntime().getNil());
-  }
-
-  @JRubyMethod
-  public static IRubyObject to(IRubyObject self, IRubyObject formatter) {
-    Ruby runtime = self.getRuntime();
-    self.callMethod(runtime.getCurrentContext(), "delete!", runtime.newString("\r"));
-    IRubyObject workingCopy = self.rbClone();
-
-    ((RubyObject)workingCopy).extend(new IRubyObject[]{formatter});
-    
-    IRubyObject workingCopyMethods = workingCopy.callMethod(runtime.getCurrentContext(), "methods");
-    IRubyObject classInstanceMethods = workingCopy.getType().callMethod(runtime.getCurrentContext(), "instance_methods");
-    IRubyObject customTags = workingCopyMethods.callMethod(runtime.getCurrentContext(), "-", classInstanceMethods);
-    ((RubyObject)workingCopy).setInstanceVariable("@custom_tags", customTags);
-    
-    if(workingCopy.callMethod(runtime.getCurrentContext(), "lite_mode").isTrue()) { 
-      return inline2(workingCopy, self, RubyHash.newHash(runtime));
-    } else {
-      return transform2(workingCopy, self);
-    }
-  }
-
-  @JRubyMethod(rest=true)
-  public static IRubyObject html_esc(IRubyObject self, IRubyObject[] args) {
-    Ruby runtime = self.getRuntime();
-    IRubyObject str = runtime.getNil(), 
-                level = runtime.getNil();
-    if(Arity.checkArgumentCount(runtime, args, 1, 2) == 2) {
-      level = args[1];
-    }
-    str = args[0];
-
-    IRubyObject new_str = RubyString.newEmptyString(runtime);
-    if(str.isNil()) {
-      return new_str;
-    }
-
-    ByteList bl = str.convertToString().getByteList();
-
-    if(bl.realSize == 0) {
-      return new_str;
-    }
-
-    byte[] bytes = bl.bytes;
-    int ts = bl.begin;
-    int te = ts + bl.realSize;
-    int t = ts, t2 = ts;
-    String ch = null;
-
-    if(te <= ts) {
-      return new_str;
-    }
-  
-    while(t2 < te) {
-      ch = null;
-      // normal + pre
-      switch(bytes[t2]) {
-        case '&':  ch = "amp";    break;
-        case '>':  ch = "gt";     break;
-        case '<':  ch = "lt";     break;
-      }
-
-      // normal (non-pre)
-      if(level != runtime.newSymbol("html_escape_preformatted")) {
-        switch(bytes[t2]) {
-          case '\n': ch = "br";     break;
-          case '"' : ch = "quot";   break;
-          case '\'': 
-            ch = (level == runtime.newSymbol("html_escape_attributes")) ? "apos" : "squot";
-          break;
-        }
-      }
-
-      if(ch != null) {
-        if(t2 > t) {
-          ((RubyString)new_str).cat(bytes, t, t2-t);
-        }
-        ((RubyString)new_str).concat(self.callMethod(runtime.getCurrentContext(), ch, RubyHash.newHash(runtime)));
-        t = t2 + 1;
-      }
-
-      t2++;
-    }
-
-
-    if(t2 > t) {
-      ((RubyString)new_str).cat(bytes, t, t2-t);
-    }
-  
-    return new_str;
-  }
-
-  @JRubyMethod
-  public static IRubyObject latex_esc(IRubyObject self, IRubyObject str) {
-    Ruby runtime = self.getRuntime();
-    IRubyObject new_str = RubyString.newEmptyString(runtime);
-    
-    if(str.isNil()) {
-      return new_str;
-    }
-
-    ByteList bl = str.convertToString().getByteList();
-    
-    if(bl.realSize == 0) {
-      return new_str;
-    }
-  
-    byte[] bytes = bl.bytes;
-    int ts = bl.begin;
-    int te = ts + bl.realSize;
-    int t = ts;
-    int t2 = ts;
-    String ch = null;
-
-    while(t2 < te) {
-      ch = null;
-
-      switch(bytes[t2]) {
-        case '{':  ch = "#123";   break;
-        case '}':  ch = "#125";   break;
-        case '\\': ch = "#92";    break;
-        case '#':  ch = "#35";    break;
-        case '$':  ch = "#36";    break;
-        case '%':  ch = "#37";    break;
-        case '&':  ch = "amp";    break;
-        case '_':  ch = "#95";    break;
-        case '^':  ch = "circ";   break;
-        case '~':  ch = "tilde";  break;
-        case '<':  ch = "lt";     break;
-        case '>':  ch = "gt";     break;
-        case '\n': ch = "#10";    break;
-      }
-
-      if(ch != null) {
-        if(t2 > t) {
-          ((RubyString)new_str).cat(bytes, t, t2-t);
-        }
-        IRubyObject opts = RubyHash.newHash(runtime);
-        ((RubyHash)opts).aset(runtime.newSymbol("text"), runtime.newString(ch));
-        ((RubyString)new_str).concat(self.callMethod(runtime.getCurrentContext(), "entity", opts));
-        t = t2 + 1;
-      }
-
-      t2++;
-    }
-
-    if(t2 > t) {
-      ((RubyString)new_str).cat(bytes, t, t2-t);
-    }
-
-    return new_str;
-  }
-
-  public boolean basicLoad(final Ruby runtime) throws IOException {
-    Init_redcloth_scan(runtime);
-    return true;
-  }
-
-  public static void Init_redcloth_scan(Ruby runtime) {
-    RubyModule mRedCloth = runtime.defineModule("RedCloth");
-    mRedCloth.defineConstant("EXTENSION_LANGUAGE", runtime.newString("Java"));
-    RubyClass super_RedCloth = mRedCloth.defineClassUnder("TextileDoc", runtime.getString(), runtime.getString().getAllocator());
-    super_RedCloth.defineAnnotatedMethods(RedclothScanService.class);
-    super_RedCloth.defineClassUnder("ParseError",runtime.getClass("Exception"),runtime.getClass("Exception").getAllocator());
-  }
-}
diff -pruN 4.2.9-5/README.rdoc 4.3.2-1/README.rdoc
--- 4.2.9-5/README.rdoc	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/README.rdoc	2016-05-24 00:19:14.000000000 +0000
@@ -1,59 +1,49 @@
 = RedCloth - Textile parser for Ruby
 
 Homepage::  http://redcloth.org
+Maintainer:: Joshua Siler https://github.com/joshuasiler
 Author::    Jason Garber
 Copyright:: (c) 2011 Jason Garber
 License::   MIT
 
+{<img src="https://travis-ci.org/jgarber/redcloth.svg" />}[https://travis-ci.org/jgarber/redcloth] {<img src="https://codeclimate.com/github/jgarber/redcloth/badges/gpa.svg" />}[https://codeclimate.com/github/jgarber/redcloth]
+
 (See http://redcloth.org/textile/ for a Textile reference.)
 
 = RedCloth
 
 RedCloth is a Ruby library for converting Textile into HTML.
 
+== Attention - Deprecating JRuby and Windows support in version 4.3
+
+In order to prioritize merging a fix for the long standing vulnerability *CVE-2012-6684*, our {new maintainer}[https://github.com/joshuasiler] has elected to stop maintaining the precompiled versions for Windows and JRuby. 
+
 == Installing
 
 RedCloth can be installed via RubyGems:
 
   gem install RedCloth
 
-It will install the appropriate Ruby, JRuby, or Win32 gem. If using JRuby,
-version 1.1.5 or greater is required.
-
 == Compiling
 
 If you just want to use RedCloth, you do NOT need to build/compile it. It is
 compiled from C sources automatically when you install the gem on the ruby
-platform. Precompiled binary gems are provided for JRuby and Win32 platforms.
+platform. Precompiled binary gems are provided for JRuby and Win32 platforms prior to version 4.3.
 
 RedCloth can be compiled with <tt>rake compile</tt>. Ragel 6.3 or greater is
 required. Again, Ragel is NOT needed to simply use RedCloth.
 
 === Supported platforms
 
-By default, the rake compile task builds a native C extension (MRI 1.8 or 1.9)
-or Java extension (JRuby 1.3). A pure Ruby version can also be generated, but
-it's super slow and Ruby 1.8-only. The JRuby and pure-Ruby extensions don't
-support multi-byte characters. Cross-compiling for win32 uses rake-compiler.
+By default, the rake compile task builds a native C extension (MRI 1.8 or 1.9). A pure Ruby version can also be generated, but it's super slow and Ruby 1.8-only, and doesn't
+support multi-byte characters. 
 
 The RedCloth::EXTENSION_LANGUAGE constant indicates in which language your
 copy of RedCloth is compiled.
 
-=== Compiling gems
-
-To compile MRI, JRuby, and win32 gems, you need rvm and rake-compiler. These
-and other dependencies can be installed with bundler. Then rake build:all
-takes care of compiling and packaging all gems.
-
-  1. gem install bundler
-  2. bundle install
-  3. rake-compiler cross-ruby VERSION=1.8.6-p398
-  4. rake-compiler cross-ruby VERSION=1.9.1-p243
-  5. rake build:all
-
 == Bugs
 
-Please submit bugs to http://jgarber.lighthouseapp.com/projects/13054-redcloth/overview
+Please submit bugs as issues to this repo.
 
 == Using RedCloth
 
@@ -69,7 +59,7 @@ Multi-line example:
 
  doc = RedCloth.new <<EOD
  h2. Test document
- 
+
  Just a simple test.
  EOD
  puts doc.to_html
@@ -122,11 +112,11 @@ of small portions of text within a parag
 
 == Links
 
-To make a hypertext link, put the link text in "quotation 
+To make a hypertext link, put the link text in "quotation
 marks" followed immediately by a colon and the URL of the link.
 
-Optional: text in (parentheses) following the link text, 
-but before the closing quotation mark, will become a title 
+Optional: text in (parentheses) following the link text,
+but before the closing quotation mark, will become a title
 attribute for the link, visible as a tool tip when a cursor is above it.
 
 Example:
@@ -141,12 +131,12 @@ Will become:
 
 To insert an image, put the URL for the image inside exclamation marks.
 
-Optional: text that immediately follows the URL in (parentheses) will 
-be used as the Alt text for the image. Images on the web should always 
-have descriptive Alt text for the benefit of readers using non-graphical 
+Optional: text that immediately follows the URL in (parentheses) will
+be used as the Alt text for the image. Images on the web should always
+have descriptive Alt text for the benefit of readers using non-graphical
 browsers.
 
-Optional: place a colon followed by a URL immediately after the 
+Optional: place a colon followed by a URL immediately after the
 closing ! to make the image into a link.
 
 Example:
@@ -167,11 +157,11 @@ Will become:
 
 == Defining Acronyms
 
-HTML allows authors to define acronyms via the tag. The definition appears as a 
-tool tip when a cursor hovers over the acronym. A crucial aid to clear writing, 
+HTML allows authors to define acronyms via the tag. The definition appears as a
+tool tip when a cursor hovers over the acronym. A crucial aid to clear writing,
 this should be used at least once for each acronym in documents where they appear.
 
-To quickly define an acronym in Textile, place the full text in (parentheses) 
+To quickly define an acronym in Textile, place the full text in (parentheses)
 immediately following the acronym.
 
 Example:
@@ -194,5 +184,3 @@ Styles are applied with curly braces.
 
     table{border:1px solid black}.
     {background:#ddd;color:red}. |a|red|row|
-
-
diff -pruN 4.2.9-5/redcloth.gemspec 4.3.2-1/redcloth.gemspec
--- 4.2.9-5/redcloth.gemspec	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/redcloth.gemspec	2016-05-24 00:19:14.000000000 +0000
@@ -6,7 +6,7 @@ require "redcloth/version"
 Gem::Specification.new do |s|
   s.name        = "RedCloth"
   s.version     = RedCloth::VERSION.to_s
-  s.authors     = ["Jason Garber", "why the lucky stiff", "Ola Bini"]
+  s.authors     = ["Jason Garber", "Joshua Siler", "Ola Bini"]
   s.description = "Textile parser for Ruby."
   s.summary     = RedCloth::SUMMARY
   s.email       = "redcloth-upwards@rubyforge.org"
@@ -23,30 +23,19 @@ Gem::Specification.new do |s|
   s.rdoc_options     = ["--charset=UTF-8", "--line-numbers", "--inline-source", "--title", "RedCloth", "--main", "README.rdoc"]
   s.require_paths   += ["lib/case_sensitive_require", "ext"]
 
-  s.files -= Dir['lib/redcloth.jar']
-  s.files -= Dir['lib/**/*.dll']
   s.files -= Dir['lib/**/*.bundle']
   s.files -= Dir['lib/**/*.so']
+
+  s.platform = 'ruby'
   
-  s.platform = RUBY_PLATFORM[/java/] || 'ruby'
-  case s.platform.to_s
-  when /java/
-    s.files += ['lib/redcloth_scan.jar']
-  else # MRI or Rubinius
-    s.files += %w[attributes inline scan].map {|f| "ext/redcloth_scan/redcloth_#{f}.c"}
-    s.files += ["ext/redcloth_scan/redcloth.h"]
-    s.extensions = Dir['ext/**/extconf.rb']
-  end
+  s.files += %w[attributes inline scan].map {|f| "ext/redcloth_scan/redcloth_#{f}.c"}
+  s.files += ["ext/redcloth_scan/redcloth.h"]
+  s.extensions = Dir['ext/**/extconf.rb']
 
-  s.add_development_dependency('bundler', '~> 1.0.10')
-  s.add_development_dependency('rake', '~> 0.8.7')
+  s.add_development_dependency('bundler', '> 1.3.4')
+  s.add_development_dependency('rake', '~> 10.0.3')
   s.add_development_dependency('rspec', '~> 2.4')
   s.add_development_dependency('diff-lcs', '~> 1.1.2')
-  
-  # Have to load these even though they're only needed for
-  # gem packaging. Otherwise, Bundler complains that they're
-  # not installed even though they're not required.
-  # See https://github.com/carlhuda/bundler/issues/issue/1021
-  s.add_development_dependency('rvm', '~> 1.2.6')
-  s.add_development_dependency('rake-compiler', '~> 0.7.1')
-end
\ No newline at end of file
+
+  s.license = "MIT"
+end
diff -pruN 4.2.9-5/spec/parser_spec.rb 4.3.2-1/spec/parser_spec.rb
--- 4.2.9-5/spec/parser_spec.rb	2016-09-13 17:38:01.000000000 +0000
+++ 4.3.2-1/spec/parser_spec.rb	2016-05-24 00:19:14.000000000 +0000
@@ -6,7 +6,7 @@ describe RedCloth do
     it "should accept options" do
       lambda {
         RedCloth.new("test", [:hard_breaks])
-      }.should_not raise_error(ArgumentError)
+      }.should_not raise_error
     end
   end
   
diff -pruN 4.2.9-5/spec/security/CVE-2012-6684_spec.rb 4.3.2-1/spec/security/CVE-2012-6684_spec.rb
--- 4.2.9-5/spec/security/CVE-2012-6684_spec.rb	2016-09-13 17:38:01.000000000 +0000
+++ 4.3.2-1/spec/security/CVE-2012-6684_spec.rb	2016-05-24 00:19:14.000000000 +0000
@@ -8,7 +8,26 @@ describe 'CVE-2012-6684' do
     # PoC from http://co3k.org/blog/redcloth-unfixed-xss-en
     output = RedCloth.new('["clickme":javascript:alert(%27XSS%27)]', [:filter_html, :filter_styles, :filter_classes, :filter_ids]).to_html
     expect(output).to_not match(/href=.javascript:alert/)
+
+    output = RedCloth.new('["clickme":jAvascript:alert(%27XSS%27)]', [:filter_html, :filter_styles, :filter_classes, :filter_ids]).to_html
+    expect(output).to_not match(/href=.jAvascript:alert/)
   end
 
+  it 'should not let javascript links pass through on images' do
+  	output = RedCloth.new('"!<javascript:alert(1)(2)!:javascript:prompt(document.domain)"').to_html
+    expect(output).to match(/src=.javascript:alert/)
+    expect(output).to match(/href=.javascript:prompt/)
+
+    output = RedCloth.new('"!<javascript:alert(1)(2)!:javascript:prompt(document.domain)"', [:filter_html, :filter_styles, :filter_classes, :filter_ids]).to_html
+    expect(output).to_not match(/src=.javascript:alert/)
+    expect(output).to_not match(/href=.javascript:prompt/)
 
+    output = RedCloth.new('"!<jAvascript:alert(1)(2)!:jAvascript:prompt(document.domain)"').to_html
+    expect(output).to match(/src=.jAvascript:alert/)
+    expect(output).to match(/href=.jAvascript:prompt/)
+
+    output = RedCloth.new('"!<jAvascript:alert(1)(2)!:jAvascript:prompt(document.domain)"', [:filter_html, :filter_styles, :filter_classes, :filter_ids]).to_html
+    expect(output).to_not match(/src=.jAvascript:alert/)
+    expect(output).to_not match(/href=.jAvascript:prompt/)
+  end
 end
diff -pruN 4.2.9-5/tasks/compile.rake 4.3.2-1/tasks/compile.rake
--- 4.2.9-5/tasks/compile.rake	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/tasks/compile.rake	2016-05-24 00:19:14.000000000 +0000
@@ -12,19 +12,16 @@ CLOBBER.include [
 ]
 
 # Load the Gem specification for the current platform (Ruby or JRuby).
-def gemspec(platform = RUBY_PLATFORM[/java/] || 'ruby')
+def gemspec(platform = 'ruby')
   Gem::Specification.load(File.expand_path('../../redcloth.gemspec', __FILE__))
 end
 
 require 'rake/extensiontask'
-require 'rake/javaextensiontask'
 require File.dirname(__FILE__) + '/ragel_extension_task'
 
-if defined?(JRUBY_VERSION)
-  Rake::JavaRagelExtensionTask.new('redcloth_scan', gemspec)
-else
-  extconf = "ext/redcloth_scan/extconf.rb"
-  file extconf do
+
+extconf = "ext/redcloth_scan/extconf.rb"
+file extconf do
     FileUtils.mkdir(File.dirname(extconf)) unless File.directory?(File.dirname(extconf))
     File.open(extconf, "w") do |io|
       io.write(<<-EOF)
@@ -36,12 +33,7 @@ have_library("c", "main")
 create_makefile("redcloth_scan")
       EOF
     end
-  end
-
-  Rake::RagelExtensionTask.new("redcloth_scan", gemspec) do |ext|
-    if ENV['RUBY_CC_VERSION']
-      ext.cross_compile = true
-      ext.cross_platform = ['i386-mingw32', 'i386-mswin32-60']
-    end
-  end
 end
+
+Rake::RagelExtensionTask.new("redcloth_scan", gemspec) do |ext|
+end
\ No newline at end of file
diff -pruN 4.2.9-5/tasks/gems.rake 4.3.2-1/tasks/gems.rake
--- 4.2.9-5/tasks/gems.rake	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/tasks/gems.rake	1970-01-01 00:00:00.000000000 +0000
@@ -1,37 +0,0 @@
-Rake::Task['build'].prerequisites.unshift('compile')
-
-namespace :build do
-    desc "Generate Windows binary gems"
-    task :win do
-      unless File.directory?(File.expand_path('~/.rake-compiler'))
-        STDERR.puts <<-EOM
-
-  You must install Windows rubies to ~/.rake-compiler with:
-
-    rake-compiler cross-ruby VERSION=1.8.6-p398
-    # (Later 1.9.1 patch levels don't compile on mingw) 
-    rake-compiler cross-ruby VERSION=1.9.1-p243
-  EOM
-        exit(1)
-      end
-      # rvm and mingw ruby versions have to match to avoid errors
-      sh "rvm ruby-1.8.6-p398@redcloth rake cross compile RUBY_CC_VERSION=1.8.6"
-      sh "rvm ruby-1.9.1-p243@redcloth rake cross compile RUBY_CC_VERSION=1.9.1"
-      # This will copy the .so files to the proper place
-      sh "rake cross native gem RUBY_CC_VERSION=1.8.6:1.9.1"
-    end
-
-    desc 'Generate JRuby binary gem'
-    task :jruby do
-      sh "rvm jruby@redcloth rake java gem"
-    end
-
-    desc "Build ruby, windows, and jruby gems into the pkg directory"
-    task :all => [
-      :clobber,
-      "rvm:spec",
-      :jruby,
-      :win,
-      :build
-    ]
-end
\ No newline at end of file
diff -pruN 4.2.9-5/tasks/ragel_extension_task.rb 4.3.2-1/tasks/ragel_extension_task.rb
--- 4.2.9-5/tasks/ragel_extension_task.rb	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/tasks/ragel_extension_task.rb	2016-05-24 00:19:14.000000000 +0000
@@ -42,17 +42,14 @@ module Rake
       {
         'scan' => {
           'c'    => "#{@ext_dir}/redcloth_scan.c",
-          'java' => "#{@ext_dir}/RedclothScanService.java",
           'rb'   => "#{@ext_dir}/redcloth_scan.rb"
         },
         'inline' => {
           'c'    => "#{@ext_dir}/redcloth_inline.c",
-          'java' => "#{@ext_dir}/RedclothInline.java",
           'rb'   => "#{@ext_dir}/redcloth_inline.rb"
         },
         'attributes' => {
           'c'    => "#{@ext_dir}/redcloth_attributes.c",
-          'java' => "#{@ext_dir}/RedclothAttributes.java",
           'rb'   => "#{@ext_dir}/redcloth_attributes.rb"
         }
       }[machine][lang]
@@ -88,7 +85,6 @@ module Rake
     def host_language_flag
       {
         'c'      => 'C',
-        'java'   => 'J',
         'rb'     => 'R'
       }[lang]
     end
@@ -96,7 +92,6 @@ module Rake
     def preferred_code_style
       {
         'c'      => 'T0',
-        'java'   => nil,
         'rb'     => 'F1'
       }[lang]
     end
@@ -117,11 +112,5 @@ module Rake
       "c"
     end
   end  
-  class JavaRagelExtensionTask < JavaExtensionTask
-    include RagelGenerationTasks
-    
-    def lang
-      "java"
-    end
-  end
+  
 end
\ No newline at end of file
diff -pruN 4.2.9-5/tasks/release.rake 4.3.2-1/tasks/release.rake
--- 4.2.9-5/tasks/release.rake	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/tasks/release.rake	2016-05-24 00:19:14.000000000 +0000
@@ -1,15 +1,16 @@
 namespace :release do
-  desc 'Upload all packages and tag git'
-  task :all => ['build:all', :release, :push_native_gems]
+  desc 'Push all gems to rubygems.org'
+  # git tag and push tag
+  # branch into stable vx.x branch
+  # change version in version.rb
+  # update changelog
+  # run rake test
 
-  desc 'Push all gems to rubygems.org (gemcutter)'
-  task :push_native_gems do
-    Dir.chdir('pkg') do
-      Dir['*.gem'].select {|g| g =~ /\w+-[^-]+-\w+.gem/ }.each do |gem_file|
-        sh("gem push #{gem_file}")
-      end
-    end
+  task :gem do
+    puts "Did you git tag and git push the tag for this release yet?"
+    #sh("rm *.gem")
+    sh("gem build redcloth.gemspec")
+    sh("gem push RedCloth-*.gem")
   end
 end
 
-Rake::Task['release'].prerequisites.unshift('build')
\ No newline at end of file
diff -pruN 4.2.9-5/tasks/rvm.rake 4.3.2-1/tasks/rvm.rake
--- 4.2.9-5/tasks/rvm.rake	2012-01-08 16:31:44.000000000 +0000
+++ 4.3.2-1/tasks/rvm.rake	2016-05-24 00:19:14.000000000 +0000
@@ -1,12 +1,14 @@
+require 'rvm'
+
 namespace :rvm do
   
-  RVM_RUBIES = ['jruby-1.5.6' , 'ruby-1.8.6-p398', 'ruby-1.9.1-p243', 'ruby-1.9.2-p136', 'ree-1.8.7-2010.02']
+  RVM_RUBIES = ['ruby-1.8.6-p398', 'ruby-1.9.1-p243', 'ruby-1.9.2-p136', 'ruby-2.2.3p173']
   RVM_GEMSET_NAME = 'redcloth'
   
   task :setup do
     unless @rvm_setup
       rvm_lib_path = "#{`echo $rvm_path`.strip}/lib"
-      $LOAD_PATH.unshift(rvm_lib_path) unless $LOAD_PATH.include?(rvm_lib_path)
+      #$LOAD_PATH.unshift(rvm_lib_path) unless $LOAD_PATH.include?(rvm_lib_path)
       require 'rvm'
       require 'tmpdir'
       @rvm_setup = true
@@ -21,7 +23,7 @@ namespace :rvm do
       # gets confused when locked to java and running ruby and vice-versa.
       STDERR << RVM.run('bundle update').stderr 
             
-      result = RVM.perform_set_operation(:rake)
+      result = RVM.run("rake test")
       STDOUT << result.stdout
       STDERR << result.stderr
     end
diff -pruN 4.2.9-5/.travis.yml 4.3.2-1/.travis.yml
--- 4.2.9-5/.travis.yml	1970-01-01 00:00:00.000000000 +0000
+++ 4.3.2-1/.travis.yml	2016-05-24 00:19:14.000000000 +0000
@@ -0,0 +1,19 @@
+language: ruby
+cache: bundler
+sudo: false
+rvm:
+  - 2.0.0
+  - 2.2.3
+  - 1.9.3
+  - 1.9.2
+  - ruby-head
+  - 1.8.7
+  - ree
+matrix:
+  fast_finish: true
+compiler:
+  - clang
+  - gcc
+before_script:
+  - bundle update
+  - bundle exec rake clobber
